# developer Einstein Vision and Language (einstein-vision-language) - Full Documentation # Code Samples and Learning Resources ## Code Samples - [salesforce-einstein-platform-apex](https://github.com/muenzpraeger/salesforce-einstein-platform-apex)—GitHub repo that contains code for an Apex-based wrapper for both the Einstein Vision APIs and the Einstein Language APIs. - [salesforce-einstein-vision-java](https://github.com/muenzpraeger/salesforce-einstein-vision-java)—GitHub repo that contains code for a Java-based wrapper for the Einstein Image Classification API. - [salesforce-einstein-vision-swift](https://github.com/muenzpraeger/salesforce-einstein-vision-swift)—GitHub repo that contains code for a Swift-based wrapper for the Einstein Image Classification API. - [salesforce-einstein-object-detection-mobile-example](https://github.com/davescruggs/salesforce-einstein-object-detection-mobile-example)—GitHub repo that contains code for a sample mobile app that uses the Einstein Object Detection API. - [Einstein Vision Quick Start Code Samples](https://github.com/MetaMind/quickstart)—GitHub repo that contains Java and Ruby code samples that show you how to generate a JWT access token, refresh a token, and make a prediction using the Einstein Image Classification API. - [EinsteinVisionPython](https://github.com/feliperyan/EinsteinVisionPython)—GitHub repo that contains code for a Python-based wrapper for the Einstein Image Classification API. - [einstein-ai](https://github.com/mshanemc/einstein-ai)—GitHub repo that contains objects and code that you can use to access Einstein Vision and Einstein Language from Salesforce. - [einstein-scala-lib](https://github.com/rajdeepd/einstein-scala-lib)—GitHub repo that contains the code for a Scala-based wrapper for the Einstein Vision APIs. - [einstein-go-apis](https://github.com/rajdeepd/einstein-go-apis)—GitHub repo that contains the code for a Golang-based wrapper for the Einstein Vision and Einstein Language APIs. **Note:** Avoid security vulnerabilities and CVEs by using the latest versions of code libraries and dependencies in any sample code. ## Apps and Services - [Einstein Vision and Language Model Builder Open Source](https://github.com/SFDC-Assets/EinsteinPlayground)—The open source version of the Einstein Vision and Language Model Builder. - [Einstein Intent Assessor](https://appexchange.salesforce.com/appxListingDetail?listingId=a0N3A00000G5qvaUAB)—An Einstein Analytics template, available on AppExchange, that helps you visualize the accuracy of your Einstein Intent models. You can identify specific labels and utterances that your model classifies with less accuracy. # Community Sentiment Model Einstein Language offers a pre-built sentiment model that you can use as long as you have a valid JWT token. This model has three classes: - positive - negative - neutral Use the community sentiment model to classify text without building your own custom model. This model was created from data that comes from multiple sources. The data is short snippets of text, about one or two sentences, and similar to what you would find in a public community or Chatter group, a review/feedback forum, or enterprise social media. This cURL command sends in a text string and returns a prediction from the model. You call the pre-built model the same way you call a custom model, but instead of passing in your own `modelId`, you pass in a `modelId` of `CommunitySentiment`. See [Prediction for Sentiment](/docs/analytics/einstein-vision-language/references). ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: multipart/form-data" -F "modelId=CommunitySentiment" -F "document=the presentation was great and I learned a lot" https://api.einstein.ai/v2/language/sentiment ``` The model returns a result similar to the following JSON. ```json { "probabilities": [ { "probability": 0.9435403, "label": "positive" }, { "probability": 0.031840604, "label": "negative" }, { "probability": 0.02461909, "label": "neutral" } ], "object": "predictresponse" } ``` # Content Takedown Salesforce Einstein respects the intellectual property rights of third parties and responds to allegations that copyrighted material has been posted, uploaded or shared on or through the machine learning-based classification and prediction service operated by Salesforce Einstein (the “Service”) without authorization from the copyright holder in accordance with the safe harbor set forth in the Digital Millennium Copyright Act (“DMCA”). Salesforce Einstein will also, in appropriate circumstances and at its discretion, disable and/or terminate the accounts of users who may infringe or repeatedly infringe the copyrights of others in accordance with the DMCA. ## Notification of Alleged Copyright Infringement If you believe that your work has been copied and made available through the Service in a way that constitutes copyright infringement, you may send a written document to Salesforce Einstein’s Designated Agent (as set forth below) that contains the following (a “Notice”): - A description of the copyrighted work that you claim has been infringed. - Identification of the URL or other specific location that contains the material that you claim infringes your copyright described in Item 1 above. You must provide us with reasonably sufficient information to locate the allegedly infringing material. - An electronic or physical signature of the owner of the copyright or of the person authorized to act on behalf of the owner of the copyright. - A statement by you that you have a good faith belief that the disputed use is not authorized by the copyright owner, its agent, or applicable law. - A statement by you that the information contained in your Notice is accurate and that you attest under the penalty of perjury that you are the copyright owner or that you are authorized to act on the owner's behalf. - Your name, mailing address, telephone number, and email address. Salesforce Einstein’s Designated Agent for Notice of claims of copyright infringement can be reached as follows: **Salesforce Einstein** 415 Mission Street, 3rd Floor San Francisco, California 94105 Attn: Legal Department, DMCA Complaint E-Mail: copyright@salesforce.com Please note that you may be liable for damages, including court costs and attorneys fees, if you misrepresent that content uploaded by a Service user is infringing your copyright. Upon receiving a proper Notice, Salesforce Einstein will remove or disable access to the allegedly infringing material and notify the alleged infringer of your claim. We will also advise the alleged infringer of the DMCA Counter Notice Procedure described below in Section B by which the alleged infringer may respond to your claim and request that we restore this material. ## Counter Notice Procedure If you believe your own copyrighted material has been removed from the Service in error, you may submit a written Counter Notice to our Designated Agent (as identified above) that includes the following: - Identification of the material that has been removed or disabled and the location at which the material appeared before it was removed or disabled. - A statement that you consent to the jurisdiction of the Federal District Court in which your address is located, or if your address is outside the United States, the Northern District of California or any other judicial district in which Salesforce Einstein may be found. - A statement that you will accept service of process from the party that filed the Notice or the party's agent. - Your name, address and telephone number. - A statement under penalty of perjury that you have a good faith belief that the material in question was removed or disabled as a result of mistake or misidentification of the material to be removed or disabled. - Your physical or electronic signature. If you send our Designated Agent a valid, written Counter Notice meeting the requirements described above, we will restore your removed or disabled material within 10 to 14 business days from the date we receive your Counter Notification, unless our Designated Agent first receives notice from the party filing the original Notice informing us that such party has filed a court action to restrain you from engaging in infringing activity related to the material in question. Please note that if you misrepresent that the disabled or removed content was removed by mistake or misidentification, you may be liable for damages, including costs and attorney's fees. ## Repeat Infringer Policy The Company may withdraw all rights and privileges relating to the Service from any user who is deemed to be a repeat infringer. This determination will be based on the number of “strikes” against the user. A “strike” is counted against a user each time there is either: (i) an adjudication by a court, arbitrator or other tribunal of competent jurisdiction that the user has engaged in copyright infringement of any kind in relation to the Service; or (ii) the Company has actual knowledge, regardless of any such adjudication, that the user has engaged in any such copyright infringement. Each adjudication or instance of knowledge counts as a separate strike. If an adjudication or instance of knowledge pertains to multiple instances of copyright infringement, it can count as multiple strikes. The Company has adopted a “three strikes and you’re out” policy under which a user who accumulates three strikes is considered a repeat infringer and may be subject to account termination. # Create a French Model In this walkthrough, you use the Einstein Intent API to create a French model to route support cases. You can then use the model to analyze text and infer what the user wants to accomplish. You use the French case routing [sample .csv file](https://einstein.ai/text/case_routing_intent_fr.csv) that we make available to you. ## Step by Step: Create a French Model ### Step 1: Get a Token A valid JWT token is required to make API calls. 1. Find your key file. If you already created an account, locate the einstein_platform.pem file that you downloaded as part of that process. This file contains your private key. 2. Install cURL. You use the cURL command-line tool throughout the following walkthrough. The tool is installed by default on Linux and OSX. If you don’t already have it installed, download it from [https://curl.haxx.se/download.html](https://curl.haxx.se/download.html). Alternatively, you can use Postman to make API calls. 3. Get a token. The Einstein Intent API uses the OAuth 2.0 JWT bearer token flow for authorization. Use the [token page](https://api.einstein.ai/token) to upload your key file and generate a JWT token. ### Step 2: Create a Dataset 1. Replace `` with your JWT token, and run the following command from the command line. This command: - Creates a dataset called Dataset de Routage de Cas from the specified .csv file by accessing the file via a URL. If you leave out the name parameter, the dataset name defaults to the name of the file: case_routing_intent_fr. - Creates five labels as specified in the .csv file. - Creates 150 examples. ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: multipart/form-data" -F "name=Dataset de Routage de Cas" -F "path=http://einstein.ai/text/case_routing_intent_fr.csv" -F "language=fr" -F "type=text-intent" https://api.einstein.ai/v2/language/datasets/upload ``` This call is asynchronous, so the response looks like this JSON. ```json { "id": 1020389, "name": "Dataset de Routage de Cas", "createdAt": "2020-03-16T17:54:51.000+0000", "updatedAt": "2020-03-16T17:54:51.000+0000", "labelSummary": { "labels": [] }, "totalExamples": 0, "available": false, "statusMsg": "UPLOADING", "type": "text-intent", "language": "fr", "numOfDuplicates": 0, "object": "dataset" } ``` 2. To verify that the data has been loaded, make a call to get the dataset. Replace `` with your JWT token, and replace `` with the ID of the dataset that you created. ```cURL curl -X GET -H "Authorization: Bearer " -H "Cache-Control: no-cache" https://api.einstein.ai/v2/language/datasets/ ``` The results look something like this JSON. You know the dataset is ready when `available` is `true` and `statusMsg` is `SUCCEEDED`. You can see that the response also returns the `language` field. ```json { "id": 1020389, "name": "Dataset de Routage de Cas", "createdAt": "2020-03-16T17:54:51.000+0000", "updatedAt": "2020-03-16T17:54:51.000+0000", "labelSummary": { "labels": [ { "id": 104866, "datasetId": 1020389, "name": "Informations d'Expédition", "numExamples": 30 }, { "id": 104867, "datasetId": 1020389, "name": "Facturation", "numExamples": 24 }, { "id": 104868, "datasetId": 1020389, "name": "Opportunité de Vente", "numExamples": 44 }, { "id": 104869, "datasetId": 1020389, "name": "Changement de Commande", "numExamples": 26 }, { "id": 104870, "datasetId": 1020389, "name": "Aide Mot de Passe", "numExamples": 25 } ] }, "totalExamples": 149, "totalLabels": 5, "available": true, "statusMsg": "SUCCEEDED", "type": "text-intent", "language": "fr", "numOfDuplicates": 1, "object": "dataset" } ``` ### Step 3: Train the Dataset to Create a Model 1. In the following command, replace `` with your JWT token, and replace `` with the ID of the dataset that you created, and run the command. ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -F "name=Modèle de Routage de Cas" -F "algorithm=multilingual-intent" -F "datasetId=" https://api.einstein.ai/v2/language/train ``` The response looks like this JSON. ```json { "datasetId": 1020389, "datasetVersionId": 0, "name": "Modèle de Routage de Cas", "status": "QUEUED", "progress": 0, "createdAt": "2020-03-16T17:54:51.000+0000", "updatedAt": "2020-03-16T17:54:51.000+0000", "modelId": "EIN6TP2LJYUOAW44EH3VH2Z4DU", "learningRate": 0, "epochs": 0, "queuePosition": 1, "modelType": "text-intent", "algorithm": "multilingual-intent", "language": "fr", "object": "training", "trainParams": null, "trainStats": null } ``` 2. Use the `modelId` to make this call and get the training status. Replace `` with your JWT token, and replace `MODEL_ID` with the ID of the model that you created. ```cURL curl -X GET -H "Authorization: Bearer " -H "Cache-Control: no-cache" https://api.einstein.ai/v2/language/train/ ``` The training status response looks like this JSON. When `status` is `SUCCEEDED`, it means the training was successful, and the model is ready for predictions. ```json { "datasetId": 1020389, "datasetVersionId": 15667, "name": "Modèle de Routage de Cas", "status": "SUCCEEDED", "progress": 1, "createdAt": "2020-03-16T17:54:51.000+0000", "updatedAt": "2020-03-16T17:54:51.000+0000", "modelId": "EIN6TP2LJYUOAW44EH3VH2Z4DU", "learningRate": 0, "epochs": 1000, "modelType": "text-intent", "algorithm": "multilingual-intent", "language": "fr", "object": "training", "trainParams": null, "trainStats": { "labels": 5, "examples": 149, "averageF1": 0.8880952380952379, "totalTime": "00:04:16:861", "transforms": null, "trainingTime": "00:04:16:280", "earlyStopping": true, "lastEpochDone": 64, "modelSaveTime": "00:00:00:262", "testSplitSize": 25, "trainSplitSize": 124, "datasetLoadTime": "00:00:00:581", "preProcessStats": null, "postProcessStats": null } } ``` ### Step 4: Send Text for Prediction Now your model is ready to go. To test it, send some text in for prediction. This cURL call takes the `modelId` of the model from which you want to return a prediction and the text string to analyze. In this case, the string in English is, “I would like to buy a soccer jersey.” 1. Replace `` with your JWT token, and replace `` with the ID of your model. Then run the command. ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: multipart/form-data" -F "modelId=" -F "document=Je voudrais acheter un maillot de foot" https://api.einstein.ai/v2/language/intent ``` The response looks like this JSON. The model predicts that the text indicates that the user is interested in buying something, so the model returns Opportunité de Vente (Sales Opportunity) as the top probability. Your app can then use this information to route the case to the correct department or sales person. ```json { "probabilities": [ { "probability": 0.95638543, "label": "Opportunité de Vente" }, { "probability": 0.02187803, "label": "Changement de Commande" }, { "probability": 0.01103622, "label": "Informations d'Expédition" }, { "probability": 0.008903132, "label": "Facturation" }, { "probability": 0.0017971398, "label": "Aide Mot de Passe" } ], "object": "predictresponse" } ``` # Data Science The terms “data science,” “machine learning,” and “artificial intelligence” are often used interchangeably, but they don’t all mean the same thing. **Data science** is a broad interdisciplinary field that uses automated, scientific methods to analyze large amounts of data and extract knowledge from that data. You can use these methods to: - Train the predictive models that are central to machine learning and artificial intelligence - Analyze, visualize, and transform the data fed into those models - Analyze the health and performance of models in production **Artificial intelligence (AI)** is an umbrella term that refers to teaching computers to perform complex tasks. The use of AI ranges from chatbots that field simple customer support questions to self-driving cars that intelligently navigate real-world traffic. AI behaves “like a human.” It can take complex, unpredictable input and respond with complex output that gives the appearance of agency. Often AI deals with the environment it’s placed in and makes various complicated decisions. Robots who play chess and the personal assistant on your phone? Those are examples of AI. **Machine learning** is a technique that takes in data and produces a refined, specific type of output. Machine learning helps a computer “learn” from examples without being explicitly programmed with step-by-step instructions. Unlike AI, which typically responds to a diverse stream of inputs and outputs, machine-learning algorithms are geared toward answering a single type of question well. We don’t expect these algorithms to perform exactly like humans. In fact, we generally expect them to answer certain questions better than a human. For that reason, machine-learning algorithms are at the forefront of efforts to diagnose diseases, predict stock market trends, and recommend music. Machine-learning techniques can help create AI, but the techniques aren’t sophisticated enough to constitute AI on their own. They can recognize and tag people in your photos or let your navigation app predict how long it takes to drive home at rush hour. In these examples, a computer takes in data, such as images that you already tagged of your friends or information from other drivers about how fast traffic is moving on the roads you need to take at 5 PM, and produces a specific output. Data science, artificial intelligence, and machine learning all overlap. A Venn diagram of these disciplines looks like this: ![MachineLearningVenn](https://developer.salesforce.com/media/machine_learning_venn.png) **Deep learning** is a type of machine learning. In deep learning, you create and train a neural network in a specific way. A neural network is a set of algorithms designed to recognize patterns. In deep learning, the neural network has multiple layers. At the top layer, the network trains on a specific set of features and then sends that information to the next layer. The network takes that information, combines it with other features and passes it to the next layer, and so on. Deep learning has increased in popularity because it has proven to outperform other methodologies for machine learning. Due to the advancement of distributed compute resources and businesses generating an influx of image, text, and voice data, deep learning can deliver insights that weren’t previously possible. ## How Machines Learn Unlike a traditional program, where every instruction for the computer to follow is laid out explicitly, step by step, machine learning lets the computer build its own steps. It does this by using data to build a model. A wide variety of machine learning algorithms are available, each suited to performing a specific task. For each machine learning task, a data scientist selects the right generic algorithm and chooses the right kind of data to feed into it. The algorithm looks for patterns in the data that map the input data to the desired output. Then the algorithm uses those patterns to build a mathematical model that describes the data. For example, say you’re designing a trip-planning app that helps consumers find the best time to buy a cheap plane ticket. First, you train a model to predict when airlines have the lowest price for a specific itinerary, given historical data on ticket pricing for the route, holidays, departure time, and how long in advance you buy the ticket. The model uses results from the past to predict what is likely to happen in the future. Then, when a customer enters the desired travel dates and route, you feed the model information about what the customer needs and get suggestions back about when the tickets are cheapest. Over time, you continue feeding data to the model, which adjusts itself, improving its suggestions as its dataset (and therefore its knowledge about pricing trends) grows. At a high level, designing a machine-learning solution involves these four steps. 1. Identify the outcome you want. For example, say that you own a clothing store. You want to bring in the maximum revenue from sales of your clothing. This outcome is the output of your algorithm. 2. Identify your inputs. Often, these inputs are the “levers” that affect your outcome. For the revenue of a clothing store, that can include price and in-store promotions. These items are the input for your algorithm. 3. Build a model that connects the input that you can control to the outcome you want. You can see how changes you make to your input affect the outcome. For example, you can see how changing the price for your products (inputs) affects your revenue (the outcome). 4. Optimize. Use your model to search for and find the best inputs to achieve the outcome you want. You can use this basic blueprint to design machine-learning solutions for a wide range of problems, such as: - Web search ranking - Autocomplete features - Credit card fraud detection - Address or handwriting recognition - Voice assistants - Language translation - Autonomous navigation (robotic vacuums, self-driving cars, space exploration vehicles) - Targeted ads based on your online activity - Facial recognition - Automatic product recommendations - Medical diagnostics - Spam filtering ## Machine Learning and Algorithms Data scientists use machine-learning models to extract information from data. But where do those models come from? A computer builds a model by taking a generic machine-learning algorithm and feeding it a set of training data. There are many machine-learning algorithms, and the broadest way to categorize them is by learning style. The two major learning styles are supervised and unsupervised. ### Supervised vs. Unsupervised The learning style of an algorithm has to do with the kind of data it uses to create a model. A supervised algorithm takes input data called “training data,” which has a known label or result. A data scientist knows what results this training data produces and can compare those known results to the actual results of the model and correct the model until it’s accurate. For example, if you want a supervised algorithm to produce a model that can identify pictures with cats, you feed it a set of labeled data containing pictures with cats and pictures without them. Because the data is labeled and you know which pictures are in each category, you can adjust the model until it reliably identifies which pictures contain cats and which don’t. An unsupervised algorithm takes in unlabeled data and creates a model by looking for patterns in that data. It can look for general patterns or rules in the data, or it can organize the data into groupings by similarity. For example, you can use an unsupervised model to examine customer data, such as purchase history and demographics, to categorize similar customers for specific marketing campaigns. ### Predictive vs. Descriptive You can also think about supervised and unsupervised models as either predictive or descriptive. A supervised model is usually predictive: It uses existing data to build a model that you can use to predict what can happen under specific conditions in the future. For example, a predictive model can predict whether changing prices increases sales and revenue. An unsupervised model is usually descriptive: It takes existing data and describes it by examining the rules and patterns in the data and categorizing or arranging it. For example, a descriptive model can tell you what kinds of customers you have by grouping them into segments based on age or spending habits. Both Einstein Vision and Einstein Language use supervised algorithms. Therefore, the models they create are predictive. ## Classification Machine-learning problems typically fall into four functional groups: classification, clustering, regression, and dimensionality reduction. ![AlgorithmsFunctionalGroups](https://developer.salesforce.com/media/algorithms_function.png) We’ll focus on classification, because Einstein Vision and Language builds classification models. A classification algorithm sorts data into categories and gives a result that’s a label, for example, “cat” or “not a cat.” Because a classification algorithm is supervised, you train it with a set of labeled data. Then you can check the accuracy of the resulting model against that data. ## The Language of Data Science The world of AI and deep learning has introduced many new terms. Understanding these terms and how they relate to each other makes it easier to work with Einstein Vision and Einstein Language. - Dataset—Contains the training data. The dataset is the starting point for an Einstein Vision or Language implementation because it contains the data from which the model is created. After you gather your data, whether it’s images or text, you use that data to create the dataset. - Label (Class)—A group of similar data inputs in a dataset that your model is trained to recognize. A label references the output name you want your model to predict. For example, the food classifier, which is trained from a multi-label dataset, contains labels like chocolate cake, pasta, carrots, and so on. - Example—A single occurrence or piece of data. For Einstein Vision, an example is an image. For Einstein Language, an example is a text string. Because the learning is supervised, each example is given a label. - Training—The process by which a model is created. A dataset is trained, and the result is a new model. - Model—A machine-learning construct used to solve a classification problem. When you send in images or text, the model returns the prediction. - Prediction—The results that the model returns as to how closely the input matches data in the dataset. - Model metrics—Provides a picture of model accuracy and how well the model will perform. Metrics include elements such as the f1 score, confusion matrix, accuracy of the test data, and accuracy of the training data. ![VisionTerms](https://developer.salesforce.com/media/vision_terms_graphic.png) ## Resources - Blog series: [Machine Learning is Fun!](https://medium.com/@ageitgey/machine-learning-is-fun-80ea3ec3c471) # Dataset and Model Best Practices ## Einstein Language - A dataset can have up to 500 labels, but we recommend a maximum of 100 labels for better model accuracy. - If you have a dataset that contains a lot of classes, increase the number of examples per label. - We recommend that an Einstein Intent or Einstein Sentiment dataset contain a maximum of 100 labels. If you need more than 100 labels, consider hierarchical classification. - We recommend less than 150 words for the length of the intent or sentiment string. This guideline applies to both a language dataset example and a string sent into a model for prediction. - During the training process, special text formatting, like emojis, words in all uppercase , and punctuation aren’t included. For example, if you add a text example containing a smiley emoji to a dataset, the emoji isn’t considered during training. Only the text is used. - When you send in text for prediction, the model doesn’t consider special text formatting and punctuation. For example, when you send the string “We had a great time! :)” to the model, the model returns a prediction for the string “We had a great time”. - Batch predictions aren’t supported. When you send text in for a prediction, you make a single API call to the `/intent` endpoint or the `/sentiment` endpoint. # Dataset Training and Retraining The training and retraining processes both create a model, but they are slightly different. There are different cases when you want to use train or retrain, and this content helps you understand when and why to use each method. ## Training Training is the process by which a model is created from your data (a dataset). In the training process, algorithms are combined with your data to create the object that returns predictions. Each time you call `/train` to train a dataset, it creates another model with a different model ID. Creating a separate model each time you train a dataset is helpful because you can compare them and then test and refine your models. For example, you train dataset A, create a model, and find that the model doesn’t perform to the level you expect. So you add some data to the dataset and train that dataset to create a new model. You can still access the previous model to compare the accuracy and other metrics as you iterate through the process. Here are some considerations to keep in mind when you train a dataset. - When you call `/train`, it creates a new model with a new model ID. - If you decide to use the new model, you must update the model ID in existing code or tools that reference the model ID. - Creating multiple models enables you to compare models as you change your dataset. ![TrainingGraphic](https://developer.salesforce.com/media/training_small.png) ## Retraining Retraining works differently. When you call `/retrain` to train a dataset, it references the dataset used to create an existing model. This method overwrites the old model with the new model, but it retains the previous model ID. For example, you train a dataset, create a model, and iterate through the process. You have an accurate model that you use in your apps. Due to changes in your business, you need to include more data in your model. Here are some considerations to keep in mind when you retrain a dataset. - Retraining overwrites the existing model, but maintains the model ID. - If you retrain using bad or incorrect data, the model is corrupted. You can’t recover the older version. - Because retraining keeps the original model ID, you don’t need to update references to the model ID. Your existing code and tools use the new model. - You must explicitly retrain a dataset when you want to update model. Retraining doesn’t occur automatically. ![RetrainingGraphic](https://developer.salesforce.com/media/retraining_small.png) # Datasets and Models A dataset contains the source text data. A model is created after a dataset is trained. The model is the construct that returns predictions. Here are some key points about datasets and models: - A dataset is the structure that contains your data, whether that data. - The training process uses the dataset to create a model. You train a dataset multiple times to create multiple models. So a single dataset can create many models. - The relationship between a dataset and a model is complete after the model is created. After a model is created, the model doesn’t reference the source dataset again unless you retrain the dataset. - You use APIs to edit a dataset. There’s no visual way to edit a dataset. If you have new data that you want to include in a model, you call the API to create a new dataset. ## Data Collection Tips - For Einstein Language, target 200–500 examples per dataset label. ## Training vs. Retraining a Dataset See [Dataset Training and Retraining](https://developer.salesforce.com/docs/analytics/einstein-vision-language/guide/dataset-training-and-retraining.md) for more information on when to train a dataset vs. retrain a dataset. ## Training Data and Test Data When you train or retrain a dataset, the training process sets aside some of the training data to test the model for accuracy. - Training data—Examples used by the training process to create the model. - Test data—Examples set aside by the training process to test the model accuracy. - Einstein Language uses 80% of the data to create the model, and 20% is used to test the model’s accuracy. You can change this ratio, also called the split, by using the `trainSplitRatio` parameter. You specify the amount of training and test data, but the actual data that the training process holds out for testing is randomly selected. This means you can see differences in models and model metrics even when those models are created from the same dataset. ## Resources - [Train a Dataset (Language)](/docs/analytics/einstein-vision-language/references) - [Retrain a Dataset (Language)](/docs/analytics/einstein-vision-language/references) # Deep Learning Development Cycle You might already be familiar with the software development life cycle (SDLC). The high-level phases of the SDLC are plan, design, code, test, and deploy. The deep learning life cycle (DLLC) has many similarities to the SDLC, but also a few key differences. If you know how the two differ, you can be prepared and plan better for your deep learning implementation. At a high level, the DLLC phases are identify the desired outcome, gather and prepare data, create the model, and test the model. Here are some key principles of the DLLC. **Data is at the center of deep learning.** Data is the means by which a model is created. So your model is only as good as the data on which it’s based. After you define your use case, or the problem that you’re solving, you must determine if you have enough data. If you don’t have enough good-quality data, the first problem to solve is how to get the data required for your implementation. For example, you want to create a model that analyzes phrases from chat transcripts to identify what a user is trying to accomplish. To create such a model, you need existing chat data. If you implemented chatbot functionality a month ago, you might not yet have enough data to build an accurate model. If you have six months of transcripts from an active chatbot, then you might have enough data. **A lot of time is spent at the beginning gathering data.** This point is a corollary to the previous principle. Even if you know that you have enough data available to create a model, chances are that data requires some processing. If you’re working with text data, you might need to parse phrases out of a transcript. It’s likely that text data needs to be formatted in the way that the API expects it. If you’re working with image data for object detection, you need bounding box data for the items in each image. At the start of your project, you must also define the categories or labels in which your data falls. In addition to gathering “correct” data examples to make predictions for the types of data you expect, you also want to gather “incorrect” data to create a negative label. **The deep learning cycle is iterative.** The model creation process involves frequent loops of model creation and testing. The overall process looks like these steps. 1. Use initial data to create the dataset and model. 2. Test the model. 3. Refine the dataset based on the model test results. 4. Create a new test model, and compare to the previous models. 5. When you’re satisfied with the results, create a final production model from the most recent dataset. You repeat steps 2–4 as often as necessary until you end up with an accurate model. By using Einstein Language, you can focus on the data and quickly get a prototype model up and running. You can use these APIs to get model metrics, test the accuracy, and quickly iterate. **The deep learning cycle is iterative, even after a model is in production.** After a model is in production, you continue to find ways to improve it. For example, you might find that certain data is consistently misclassified, perhaps data that you didn’t expect to be sent for classification. In this case, you might want to add a label and the data to the dataset and retrain it. Your business might change and require adding a new label and data to the dataset and model. Expect that your models continue to change even after they’re in production. It’s important to expect these changes so that you can allocate resources and time to maintaining the model. ![AgileAISprints](https://developer.salesforce.com/media/agile_ai_sprints_ran_lee.png) # Detect Text and Entities in Business Cards To return text for a business card, specify a modelId of `OCRModel` and `task` parameter of `contact`. In addition to the text, the model returns the entity type for each text element that it detects. ![BusinessCardOriginal](https://developer.salesforce.com/media/business_card_original.jpeg) The cURL call looks like this. ```cURL curl -X POST -H "Authorization: Bearer " -F sampleLocation="https://www.asianbusinesscards.com/wp-content/uploads/2019/03/chinese-business-card-translation-samples-walmart-890-eng.jpg" -F task="contact" -F modelId="OCRModel" https://api.einstein.ai/v2/vision/ocr ``` ![BusinessCardOCRWithCallouts](https://developer.salesforce.com/media/business_card_ocr.png) The response looks like this JSON. ```json "tag": "OTHER" } }, { "probability": 0.9989197, "label": "Director Operations and Logistics", "boundingBox": { "minX": 53, "minY": 105, "maxX": 466, "maxY": 134 }, "attributes": { "tag": "OTHER", "pageNumber": "1" } }, { "probability": 0.9978701, "label": "Randy E. Cornwell", "boundingBox": { "minX": 53, "minY": 73, "maxX": 297, "maxY": 103 }, "attributes": { "tag": "PERSON", "pageNumber": "1" } }, { "probability": 0.99883646, "label": "S-1050-06 Headquarters Building", "boundingBox": { "minX": 55, "minY": 384, "maxX": 467, "maxY": 413 }, "attributes": { "tag": "OTHER", "pageNumber": "1" } }, { "probability": 0.9981871, "label": "Houston TX 77042 USA 2881 CityWest Blvd.", "boundingBox": { "minX": 53, "minY": 416, "maxX": 350, "maxY": 472 }, "attributes": { "tag": "ADDRESS", "pageNumber": "1" } }, { "probability": 0.9984518, "label": "284.575.2884", "boundingBox": { "minX": 547, "minY": 384, "maxX": 820, "maxY": 412 }, "attributes": { "tag": "PHONE", "pageNumber": "1" } }, { "probability": 0.9984518, "label": "phone ", "boundingBox": { "minX": 547, "minY": 384, "maxX": 820, "maxY": 412 }, "attributes": { "tag": "OTHER", "pageNumber": "1" } }, { "probability": 0.9973475, "label": "281.889.0997", "boundingBox": { "minX": 541, "minY": 415, "maxX": 825, "maxY": 439 }, "attributes": { "tag": "MOBILE_PHONE", "pageNumber": "1" } }, { "probability": 0.9973475, "label": "mobile ", "boundingBox": { "minX": 541, "minY": 415, "maxX": 825, "maxY": 439 }, "attributes": { "tag": "OTHER", "pageNumber": "1" } }, { "probability": 0.89205074, "label": "re.comwell@phillips86.com", "boundingBox": { "minX": 478, "minY": 444, "maxX": 782, "maxY": 476 }, "attributes": { "tag": "EMAIL", "pageNumber": "1" } }, { "probability": 0.992919, "label": "Phillips", "boundingBox": { "minX": 692, "minY": 79, "maxX": 780, "maxY": 100 }, "attributes": { "tag": "OTHER", "pageNumber": "1" } }, { "probability": 0.90038645, "label": "66", "boundingBox": { "minX": 693, "minY": 113, "maxX": 777, "maxY": 162 }, "attributes": { "tag": "OTHER", "pageNumber": "1" } }, { "probability": 0.9908977, "label": "Phillips66.com", "boundingBox": { "minX": 53, "minY": 198, "maxX": 238, "maxY": 226 }, "attributes": { "tag": "WEBSITE", "pageNumber": "1" } }, { "probability": 0.89205074, "label": "phillips86", "boundingBox": { "minX": 630, "minY": 444, "maxX": 782, "maxY": 476 }, "attributes": { "tag": "ORG", "pageNumber": "1" } } ], "object": "predictresponse" } ``` # Detect Text and Tables Some images contain tabular data. To return the table data for each text element, specify the `tabulatev2` model and a `task` parameter value of `table`. ![TableOriginal](https://developer.salesforce.com/media/table_original.png) The cURL call looks like this. ```cURL curl -X POST -H "Authorization: Bearer " -F sampleContent="@/filepath/table.png" -F task="table" -F modelId="tabulatev2" https://api.einstein.ai/v2/vision/ocr ``` The response looks like this JSON. ```json { "task": "table", "probabilities": [ { "probability": 0.9952141, "label": "City", "boundingBox": { "minX": 158, "minY": 50, "maxX": 214, "maxY": 82 }, "attributes": { "cellLocation": { "rowIndex": 1, "colIndex": 1 }, "pageNumber": "1" } }, { "probability": 0.99889404, "label": "Number of Events", "boundingBox": { "minX": 405, "minY": 50, "maxX": 659, "maxY": 75 }, "attributes": { "cellLocation": { "rowIndex": 1, "colIndex": 2 }, "pageNumber": "1" } }, { "probability": 0.9988783, "label": "Number of Stations", "boundingBox": { "minX": 773, "minY": 51, "maxX": 1048, "maxY": 75 }, "attributes": { "cellLocation": { "rowIndex": 1, "colIndex": 3 }, "pageNumber": "1" } }, { "probability": 0.99629766, "label": "San Francisco", "boundingBox": { "minX": 91, "minY": 115, "maxX": 282, "maxY": 140 }, "attributes": { "cellLocation": { "rowIndex": 2, "colIndex": 1 }, "pageNumber": "1" } }, { "probability": 0.9942451, "label": "100", "boundingBox": { "minX": 511, "minY": 116, "maxX": 557, "maxY": 140 }, "attributes": { "cellLocation": { "rowIndex": 2, "colIndex": 2 }, "pageNumber": "1" } }, { "probability": 0.97811675, "label": "21", "boundingBox": { "minX": 894, "minY": 116, "maxX": 924, "maxY": 139 }, "attributes": { "cellLocation": { "rowIndex": 2, "colIndex": 3 }, "pageNumber": "1" } }, { "probability": 0.9973557, "label": "San Diego", "boundingBox": { "minX": 117, "minY": 180, "maxX": 256, "maxY": 213 }, "attributes": { "cellLocation": { "rowIndex": 3, "colIndex": 1 }, "pageNumber": "1" } }, { "probability": 0.99561936, "label": "123", "boundingBox": { "minX": 510, "minY": 182, "maxX": 558, "maxY": 206 }, "attributes": { "cellLocation": { "rowIndex": 3, "colIndex": 2 }, "pageNumber": "1" } }, { "probability": 0.9816425, "label": "18", "boundingBox": { "minX": 896, "minY": 181, "maxX": 926, "maxY": 206 }, "attributes": { "cellLocation": { "rowIndex": 3, "colIndex": 3 }, "pageNumber": "1" } }, { "probability": 0.9973557, "label": "San Jose", "boundingBox": { "minX": 125, "minY": 246, "maxX": 248, "maxY": 271 }, "attributes": { "cellLocation": { "rowIndex": 4, "colIndex": 1 }, "pageNumber": "1" } }, { "probability": 0.9696964, "label": "53", "boundingBox": { "minX": 517, "minY": 247, "maxX": 549, "maxY": 270 }, "attributes": { "cellLocation": { "rowIndex": 4, "colIndex": 2 }, "pageNumber": "1" } }, { "probability": 0.9926605, "label": "189", "boundingBox": { "minX": 888, "minY": 247, "maxX": 935, "maxY": 271 }, "attributes": { "cellLocation": { "rowIndex": 4, "colIndex": 3 }, "pageNumber": "1" } } ], "object": "predictresponse" } ``` The above JSON describes Einstein's detection of the table elements, and is depicted below: ![TableWithOCRCallouts](https://developer.salesforce.com/media/table_ocr_with_caps.png) ## Multiple Tables on a Page When an image contains more than one table, Einstein returns tabular data for each table in the image. The following image depicts how the tables and fields are denoted in the JSON. (The JSON is not provided). With this example, three tables are identified: One 3x2, one 2x5, and one 2x2. The values in the second row of the 2x2 table cells will be identified separately, resulting in a 2x6 JSON table definition. ![MultiTableExample](https://developer.salesforce.com/media/multi-table-example.png) **note:** We currently support only the content confined within the individual tables. Free text in the image which lies outside of a table border is not processed. # Detect Text in Standard Forms Einstein OCR (optical character recognition) can now extract text from a variety of common forms. Einstein OCR supports these standard forms. - Driver's license, only United States, including Washington, DC - Form 1040, only 2019 - Form W-2 - Passport, only Australia, Canada, United Kingdom, and United States - Pay stub, generated by ADP or Workday - Permanent Resident Card, only United States including Washington, DC When you call the API, you send in the form as an image or PDF, and specify the `tabulatev2` modelId. The JSON response contains key-value pairs for each field in the form. ![JaneDoeDriversLicenseWithCallouts](https://developer.salesforce.com/media/jane_doe_dl_with_callouts.png) 1. The **key** is the label of the form field detected by Einstein OCR. If you fill out the form, the key is the text that you read to see what data to put in that field. 2. The **value** is the data of the actual form field. The model infers the document layout and word relationships, then extracts the entity and value for each field in the form. For example, in a driver's license, Einstein links together the issue date of the license (09/13/2020), how the issue date is referred to on the license (4a ISS), and the entity type (issue_date), which is a consistent field name across all variations of driver’s licenses. In addition, when the model detects a compound field (such as an address), it normalizes the text of that field into its constituent parts. Here are some examples of key-value pairs from a form. | Form | Form Key | Form Value | Normalized Text | | ---------------- | ------------------------------------- | ------------------------------------ | ------------------------------------------------------------------------------------------------------ | | Form 1040 | `a Employee's social security number` | 123-45-6789 | n/a | | Driver’s license | `3 DOB` | 09/13/1999 | n/a | | Form W-2 | `Employee Address` | 123 Sample Street Phoenix, AZ, 01234 | `{\\”Street\\”:\\”123 Sample Street\\”,\\”City\\”Phoenix\\”,\\”State\\”:”\\AZ\\”,”\\ZipCode\\”:01234}` | When we detect a form field as an address, we normalize that text and return fields populated with street, city, state, postal code, and country. When an address has multiple lines (as in the case of _P.O. Box_, or _Apartment_), **normalizedText** returns the original text. if there’s a line separator in the text field, it will be present in the **normalizedText** field. **note:** Currently only U.S. addresses are normalized. See the [Entity Normalization](https://developer.salesforce.com/docs/analytics/einstein-vision-language/Detect-Entities-in-Text/entity-normalization.md) for more details on how detected text is normalized. # Driver's License This table lists the entities returned by the OCR model for a driver's license. Supports licenses only from the United States, including Washington, DC. | Entity name | Additional info | Possible form keys | | ------------------------ | -------------------------------------------------------------------------------- | -------------------------------------------------------------------------------------------------------------------------- | | `address` | | 8
8 ADDRESS | | `audit` | Louisiana driver’s license only. | AUDIT | | `class` | | 9 Class | | `date_of_birth` | | 3 DOB
Date of Birth
D.O.B.
DOB | | `document_discriminator` | | 5 DD
DD | | `donor` | | ORGAN DONOR
DONOR | | `duplicate_number` | Alaska driver’s license only. | DUPLICATE NUM | | `dups` | Pennsylvania driver’s license only. | | | `endorsements` | | 9a End
9a END
9a ENDORSEMENTS
End
END | | `expiration_date` | | Expires
4b EXP | | `eyes` | | 18 Eyes
18 EYES
EYES | | `first` | Oregon driver’s license only. | FIRST | | `first_name` | | 2
FN | | `gender` | | 15 Sex
15 SEX
Sex
SEX | | `hair` | | 19 Hair
19 HAIR
Hair
HAIR | | `height` | | 16 HGT
16 Hgt
Height
HGT | | `issue_date` | | 4a ISS
Issued
ISS | | `last_name` | | 1
LN | | `name` | Full name. Returned only when the first name and last name are on the same line. | | | `number` | | 4d DLN
4d DL NO.
DL
Number | | `office` | Louisiana driver’s license only. | | | `parish` | Louisiana driver’s license only. | | | `previous_type` | Colorado driver’s license only. | | | `race` | North Carolina driver’s license only. | | | `replaced` | Florida driver’s license only. | | | `restrictions` | | 12 Rest
12 REST:
12 REST
12 RESTRICTIONS
12 Restrictions
RESTRICTIONS
Restrictions
RSTR | | `social_security_number` | Louisiana driver’s license only. | | | `state` | | | | `type` | Illinois driver’s license only. | | | `weight` | | 17 Wgt
17 WGT
WGT | # Einstein Intent Quick Start This quick start shows you how to use the Einstein Intent API to create a model to route support cases. You can then use this model to analyze text and infer what the user wants to accomplish. ## Prerequisites - **Find your key file**—If you already created an account, locate the `einstein_platform.pem` file that you downloaded as part of that process. This file contains your private key. - **Find your key file**—If you already created an account, locate the `einstein_platform.pem` file that you downloaded as part of that process. This file contains your private key. - **Install cURL**—We use the cURL command line tool throughout the following steps. This tool is installed by default on Linux and OSX. If you don’t already have it installed, download it from [https://curl.haxx.se/download.html](https://curl.haxx.se/download.html) - **Get a Token**—The Einstein Vision and Language APIs use OAuth 2.0 JWT bearer token flow for authorization. Use the [token page](https://api.einstein.ai/web/token) to upload your key file and generate a JWT token. For step-by-step instructions, see [Set Up Authorization](https://developer.salesforce.com/docs/analytics/einstein-vision-language/guide/set-up-auth.md). ## Step 1: Define Your Classes and Gather Data In this step, you define the labels that you want the model to output when text is sent into the model for prediction. Then you gather text data for each of those labels, and that text is used to create a model. This is typically the most time-consuming part of of the process. To make it easier for you to go through these steps, we provide a case routing [.csv file](http://einstein.ai/text/case_routing_intent.csv) that you can use. The labels in the case routing dataset define the intent behind the text. The intent can then be used to route that case to the right department. Those labels are: - `Billing` - `Order Change` - `Password Help` - `Sales Opportunity` - `Shipping Info` ## Step 2: Create the Dataset In this step, you use the data you gathered to create a dataset. In the following command, replace `` with your JWT token and run the command. This command: - Creates a dataset called `case_routing_intent` from the specified .csv file by accessing the file via a URL - Creates five labels as specified in the .csv file - Creates 150 examples ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: multipart/form-data" -F "data=case_routing_intent.csv" -F "type=text-intent" https://api.einstein.ai/v2/language/datasets/upload ``` This call is asynchronous, so the response looks like this JSON. ```json { "id": 1004804, "name": "case_routing_intent.csv", "createdAt": "2019-06-22T19:31:58.000+0000.", "updatedAt": "2019-06-22T19:31:58.000+0000", "labelSummary": { "labels": [] }, "totalExamples": 0, "available": false, "statusMsg": "UPLOADING", "type": "text-intent", "language": "en_US", "numOfDuplicates": 0, "object": "dataset" } ``` To verify that the data has been loaded, make a call to get the dataset. Replace `` with your JWT token and `` with ID of the dataset you created. ```cURL curl -X GET -H "Authorization: Bearer " -H "Cache-Control: no-cache" https://api.einstein.ai/v2/language/datasets/ ``` The results look something like this JSON. You know the dataset is ready when `available` is `true` and `statusMsg` is `SUCCEEDED`. ```json { "id": 1004804, "name": "case_routing_intent.csv", "createdAt": "2019-06-22T19:31:58.000+0000", "updatedAt": "2019-06-22T19:31:59.000+0000", "labelSummary": { "labels": [ { "id": 23649, "datasetId": 1004804, "name": "Order Change", "numExamples": 26 }, { "id": 23650, "datasetId": 1004804, "name": "Sales Opportunity", "numExamples": 44 }, { "id": 23651, "datasetId": 1004804, "name": "Billing", "numExamples": 24 }, { "id": 23652, "datasetId": 1004804, "name": "Shipping Info", "numExamples": 30 }, { "id": 23653, "datasetId": 1004804, "name": "Password Help", "numExamples": 26 } ] }, "totalExamples": 150, "totalLabels": 5, "available": true, "statusMsg": "SUCCEEDED", "type": "text-intent", "language": "en_US", "numOfDuplicates": 0, "object": "dataset" } ``` ## Step 3: Train the Dataset to Create the Model Use this cURL command to train the dataset and create a model. Replace `` with your JWT token and `` with ID of the dataset you created. ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: multipart/form-data" -F "name=Case Routing Model" -F "datasetId=" https://api.einstein.ai/v2/language/train ``` The response looks like this JSON. ```json { "datasetId": 1004804, "datasetVersionId": 0, "name": "Case Routing Model", "status": "QUEUED", "progress": 0, "createdAt": "2017-06-22T19:39:38.000+0000", "updatedAt": "2017-06-22T19:39:38.000+0000", "modelId": "5SXGNLCCOFGTMNMQYEOTAGBPVU", "learningRate": 0, "epochs": 0, "queuePosition": 1, "modelType": "text-intent", "algorithm": "multilingual-intent", "language": "en_US", "object": "training", "trainParams": null, "trainStats": null } ``` Use the `modelId` to make this call and get the training status. Replace `` with your JWT token and `MODEL_ID` with the ID of the model you created. ```cURL curl -X GET -H "Authorization: Bearer " -H "Cache-Control: no-cache" https://api.einstein.ai/v2/language/train/ ``` The training status response looks like this JSON. The `status` of `SUCCEEDED` means that the model is ready for predictions. ```json { "datasetId": 1004804, "datasetVersionId": 2473, "name": "Case Routing Model", "status": "SUCCEEDED", "progress": 1, "createdAt": "2019-06-22T19:39:38.000+0000", "updatedAt": "2019-06-22T19:43:39.000+0000", "modelId": "5SXGNLCCOFGTMNMQYEOTAGBPVU", "learningRate": 0, "epochs": 300, "modelType": "text-intent", "algorithm": "multilingual-intent", "language": "en_US", "object": "training", "trainParams": null, "trainStats": { "labels": 5, "examples": 150, "averageF1": 0.9492063492063492, "totalTime": "00:03:54:159", "transforms": null, "trainingTime": "00:03:53:150", "earlyStopping": true, "lastEpochDone": 267, "modelSaveTime": "00:00:01:561", "testSplitSize": 28, "trainSplitSize": 122, "datasetLoadTime": "00:00:01:008", "preProcessStats": null, "postProcessStats": null } } ``` ## Step 4: Send Text in for Prediction Now your model is ready to go! To test it out, send some text in for prediction. This cURL call takes the `modelId` of the model from which you want to return a prediction and the text string to analyze. Replace `` with your JWT token and `` with the ID of your model. ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: multipart/form-data" -F "modelId=" -F "document=how is my package being shipped?" https://api.einstein.ai/v2/language/intent ``` The response looks like this JSON. The model predicts that the text indicates that the user has a comment or question about shipping, so the model returns `Shipping Info` as the top probability. Your app can then use this information to route the case to the right department or agent. ```json { "probabilities": [ { "label": "Shipping Info", "probability": 0.82365495 }, { "label": "Sales Opportunity", "probability": 0.12523715 }, { "label": "Billing", "probability": 0.0487557 }, { "label": "Order Change", "probability": 0.0021365683 }, { "label": "Password Help", "probability": 0.0002156619 } ], "object": "predictresponse" } ``` # Einstein OCR Model Card The model analyzed in this card returns text, probabilities, and other information identified in an image or PDF. Get information about training data, use cases, features, and other considerations for the optical character recognition (OCR) model. ## Model Details ### Person or Organization Salesforce AI Research ### Model Date and Version - February 2022 - The model doesn’t have numbered versioning. When a fix is sent out, it's deployed everywhere so customers are always running on the latest version. - Minor changes can occur throughout the release. - Major changes can occur and are communicated via release notes. ### Model Type Vision model for character recognition. Einstein OCR has three modules. The first module detects the text in an image. The second module identifies characters in the text that was identified in the first module, and converts it character by character to a string. The third module uses this computed text to tag the text with an entity such as person, phone number, or address. The modules use a convolutional neural network (CNN) plus a combination of a CNN and long short-term memory (LSTM) network. ### License Einstein OCR is available to Salesforce customers that have any SKU for Einstein Vision and Language. ### Questions or Comments Send questions or comments about the model to vision-team@salesforce.com. For more info, see [Einstein OCR documentation](https://developer.salesforce.com/docs/analytics/einstein-vision-language/guide/einstein-ocr.md). ## Intended Use The Einstein OCR model detects alphanumeric text and common special characters (such as ’#’ and ‘&’) in an image. ### Primary Intended Users The Einstein OCR model is designed for enterprise customers. Users can access the model via REST API or embed the API in a Salesforce application. ### Primary Intended Uses - **OCR text:** Identifies typed and handwritten text in a document or image and returns the relative position of that text. Use cases include: - VIN number detection - serial number detection - **OCR entity:** Identifies text in an image and returns the relative position and the associated entity. To build on OCR text, it identifies text and then identifies the entity that the text represents. Use cases include extracting contact information from business cards. - **OCR table:** Identifies text in an image and returns the relative position and associated cell number. To build on OCR text, it identifies tables in the text and maps entries to a specific table cell. Use cases include digitizing tables such as price sheets. ### Out-of-Scope Uses - The Einstein OCR model currently only supports English. See the Note section for details on supported characters. - The model doesn't support checkboxes, or circled answers. - The model is optimized for short-form prediction rather than the identification of characters, words, or entities in long-form sentences or paragraphs. - Certain use cases are prohibited under the [Salesforce Acceptable Use Policy](https://www.salesforce.com/content/dam/web/en_us/www/documents/legal/Agreements/policies/ExternalFacing_Services_Policy.pdf). - A user can't submit data prohibited by the [Security, Privacy and Architecture](https://www.salesforce.com/content/dam/web/en_us/www/documents/legal/misc/einstein-platform-security-privacy-and-architecture.pdf) documentation, Sensitive Data section. ## Limitations The quality of a user's input can affect the accuracy of the results. These factors can affect text recognition accuracy. - Low quality images such as those downloaded from unknown sources or poorly scanned - Low light - Low resolution - High skew or perspective - Varying density of words in the document - Length of strings - Excessively cursive or handwritten text that's illegible - Font of the typed text These factors can affect entity recognition accuracy. - Addresses with varied formats that differ between countries. For example, apartment numbers, postal codes, and so on - Birth dates in different formats - Names in different cultures - Various genders ## Metrics **Precision and recall** are used to evaluate where the text is within an image (the bounding box). **Word-level accuracy** is used to evaluate character recognition in identified text. The entity **F1** score is used to discern the accuracy of entity tags identified for text. The overall model is also evaluated using an **F1 score**. The score calculation is based on the precision and recall and the word-level accuracy mentioned above. ## Training and Evaluation Data The training dataset is composed of data from these open-source libraries: - Born-Digital Images, found on [https://rrc.cvc.uab.es](https://rrc.cvc.uab.es), in the Challenges picklist - Focused Scene Text, found on [https://rrc.cvc.uab.es](https://rrc.cvc.uab.es), in the Challenges picklist - MLT, found on [https://rrc.cvc.uab.es](https://rrc.cvc.uab.es), in the Challenges picklist - COCO-Text, found on [https://rrc.cvc.uab.es](https://rrc.cvc.uab.es), in the Challenges picklist - IIIT-HWS, found on https://github.com/kris314/hwnet/tree/master/iiit-hws (1) - The UNIPEN on-line handwritten samples collection, found on http://www.unipen.org/products.html (2) In addition to the open-source libraries, synthetic datasets were used. Synthetic datasets were created by picking a scene or plain white background and then imposing randomly selected words onto the background and changing certain attributes such as font, character size, or skew. The entity recognition capabilities use a combination of in-house named-entity recognition (NER) models, the Stanford business card dataset, and an in-house business card dataset. The data used to evaluate the model was gathered from the sources listed above. The evaluation and training data sets are different subsets of the source data that don’t overlap. ## Quantitative Analyses The results reported here are from a publicly available challenge dataset, [ICDAR Focused scene text](https://rrc.cvc.uab.es/?ch=2&com=introduction). This dataset consists of real-world scenes such as storefronts and street signs, with images primarily focused on text content. This scenario is typical for text reading applications where the user explicitly directs the camera’s focus on the text content of interest. The challenge in this dataset arises from complex text orientation and complex backgrounds. Complex text orientation necessitates estimating skew in addition to the location and content of the text. Complex backgrounds can reduce contrast of the text and introduce false positives in the form of random patterns that appear like text. The ICDAR dataset was designed to encourage the research community to develop solutions for text reading in real-world images, and the challenge allowed for the OCR system to limit the words to a fixed vocabulary (as with the State of the Art (SoTA) benchmark reported below). Such a limitation can be helpful in correcting OCR errors because the words to be detected in the test set are present in the fixed vocabulary. And the search space for a word in a test image decreases from potentially infinite (all possible combinations of alphabets and numbers) to a small number of words in the specified vocabulary. The SoTA models reported here use a general vocabulary set to aid in text prediction, and are trained on this dataset. But our results don’t use a vocabulary because the models support OCR applications that can’t be captured by a vocabulary, such as vehicle identification number (VIN) or serial number scanning. The models aren't trained on this dataset exclusively. A generic model is used that’s more robust and addresses a wider range of challenges. The F1 score diverges from the SoTA results by just 6.17%. **Evaluation Metric:** F1 score **Salesforce Research Model ID:** `scene` | | **Salesforce Research** | **SoTA Research Benchmark\*** | | -------------------- | ----------------------- | ----------------------------- | | **Fixed Vocabulary** | No | Yes | | **Usage** | Real world | Fine tuned for the dataset | | **F1 Score** | 79.61 | 85.78 | \*[SoTA Research Benchmark](https://rrc.cvc.uab.es/?ch=2&com=evaluation&task=4&f=3&e=1) ## Ethical Considerations The text is processed into a string character by character. Because dictionaries aren’t referenced, underlying bias is not an issue. But the supported characters are limited to the Roman alphabet, which could be advantageous to English-language individuals, companies, and organizations. Certain entities are identified after the text is converted character by character to a string. So the identification of certain entities may be challenging for the model. For example, first or last names from certain regional, ethnic, or religious groups sometimes are recognized with higher accuracy. This issue can include non-binary gender or varied birth date formats. ## Note - Only text that contains characters found in the supported character list is identified. Languages with characters other than those in the supported character list aren’t supported. An increase in the supported characters and languages is planned. - Only entities in the supported entity list are identified in this version of the model. - Only phone numbers displayed in the format of the supported phone number formats are identified in this version of the model. - The Detect Text API provides for more than one prediction model. Each has a unique modelId specifier (for example, _OCRModel_ and _tabulatev2_). For best accuracy, use the modelId and task combinations we recommend. ### Supported Characters These special characters are supported. `` !"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~£≈ `` ### Supported Entities These entities are supported. - `ADDRESS` - `EMAIL` - `FAX` - `HOME_PHONE` - `MOBILE_PHONE` - `OFFICE_PHONE` - `ORG` - `PERSON` - `WEBSITE` ### Phone Number Formats Phone numbers with these country-specific formats are supported. - `CA` - `CN` - `DE` - `ES` - `FR` - `GB` - `IN` - `IT` - `MX` - `JP` - `PT` - `US` ### Service Numbers We can also identify service and emergency numbers (such as 911) in the locales listed below. Our support for service numbers is limited to these specific locales. | **Locale** | **Locale Code** | **Service Number** | | ---------------------------- | --------------- | ------------------ | | Chinese, Simplified (China) | zh_cn | 110, 119, 120 | | Chinese, Traditional (China) | zh_tw | 110,119,120 | | Danish (Denmark) | da | 112 | | Dutch (Netherlands) | nl_nl | 112 | | English (U.S.A.) | en_us | 911 | | English (U.K) | en_gb | 999, 112 | | French (France) | fr | 15, 17, 18, 112 | | German (Germany) | de | 110, 112 | | Italian (Italy) | it | 112 | | Japanese (Japan) | ja | 110, 119 | | Korean (Korea) | ko | 112, 119 | | Portuguese (Brazil) | pt_br | 190, 192, 193 | | Portuguese (Portugal) | pt_pt | 112 | | Russia (Russian) | ru | 101,102, 103, 112 | | Spanish (Spain) | es | 112 | | Swedish (Sweden) | sv | 112 | (1) Praveen Krishnan and C.V. Jawahar, Generating Synthetic Data for Text Recognition, arXiv preprint arXiv:1608.04224, 2016. (2) The database is provided by the [Unipen Foundation](http://www.unipen.org/images/178_unipen-logo.jpg). Einstein Vision and Language API # Einstein Vision and Language API * * * **Important:** Salesforce is retiring Einstein Vision and Language, and your subscription will not be renewable after May 1, 2024. You can continue using Einstein Vision and Language through your Order Term. To avoid interruptions, transition any Salesforce org using Einstein Vision and Language to another solution before your subscriptions expire. We will be communicating additional details to you soon. If you have questions, contact your Account Executive about your subscriptions. * * * You access the Einstein Vision and Einstein Language services via these standard REST API calls. Use the APIs to programmatically work with datasets, labels, examples, models, and predictions. **Einstein Vision and Language Are HIPAA Compliant** Einstein Vision and Language are Health Insurance Portability and Accountability Act (HIPAA) compliant. Einstein Vision and Language meet the strict HIPAA standards for processing customers' protected health information (PHI). HIPAA compliance positions Einstein Vision and Language services to provide capabilities that can be used in the highly regulated healthcare sector. ### API Error Codes and Messages If an API call is unsuccessful, it returns an HTTP error code. If the error is known, you receive a message in the response body. Known errors are returned in the response body in this format. ```json { "message": "Invalid authentication scheme" } ``` #### All | HTTP Code | HTTP Message | API Message | Resource | Possible Causes | | --- | --- | --- | --- | --- | | 401 | Unauthorized | Invalid access token | Any | The access token is expired. | | 401 | Unauthorized | Invalid authentication scheme | Any | An `Authorization` header was provided, but the token isn't properly formatted. | | 5XX | Internal server error; Service unavailable | None | Any | Our systems encountered and logged an unexpected error. Please contact us if you continue to see the error. | #### Datasets Error codes that can occur when you access datasets, labels, or examples. | HTTP Code | HTTP Message | API Message | Resource | Possible Causes | | --- | --- | --- | --- | --- | | 400 | Bad Request | None | Any dataset, label, or example resources. | The request couldn't be fulfilled because the HTTP request was malformed, the Content Type was incorrect, there were missing parameters, or a parameter was provided with an invalid value. | | 400 | Bad Request | The `name` parameter is required to create a dataset. | `POST /language/datasets` | The `name` parameter was passed in, but no value was provided. | | 400 | Bad Request | Uploading a dataset requires either the `data` field. | `POST /language/datasets/upload` | The path to the local .zip file or the URL to the .zip file in the cloud wasn't specified. | | 400 | Bad Request | The `data` parameter cannot be duplicated. | `POST /language/datasets/upload` | The `data` parameter cannot be duplicated. | | 400 | Bad Request | The dataset is not yet available for update, try again once the dataset is ready. | `PUT /language/datasets//upload` | You're adding examples to a dataset that's currently being created. You must wait for the dataset to become available before you can add examples to it. | | 400 | Bad Request | Failed to download the dataset from the public URL. | `POST /language/datasets/upload`; `POST /language/datasets/upload/sync` | The API can't access the dataset file via the URL provided. When specifying the URL for a .zip file in a cloud drive service like Dropbox, be sure it's a direct file link, not an interactive download page. Example: `https://www.dropbox.com/s/abcdxyz/mountainvsbeach.zip?dl=1`. | | 400 | Bad Request | Supported dataset types: \[image, image-detection, image-multi-label\] | `POST /language/datasets/upload` | The `type` request parameter contains a value that isn't a valid dataset type. | | 400 | Bad Request | Example max size supported is 1024000. | `POST /language/datasets//examples` | The image file being added as an example exceeds the maximum file size of 1 MB. | | 404 | Not Found | None | Any dataset, label, or example resources. | The requested REST resource doesn't exist or you don't have permission to access the resource. | | 404 | Not Found | Unable to find dataset. | `GET /language/datasets/` | You don't have access to the dataset, or the dataset was deleted. | | 404 | Not Found | Unable to find dataset. | `DELETE /language/datasets/` | You don't have access to the dataset, or the dataset was deleted. | | 404 | Bad Request | Duplicate labels are not allowed. | `POST /language/datasets` | The call is trying to create a label with a name that exists in the dataset. Label names must be unique within a dataset. | | 503 | Service Unavailable | Operation timed out! | `GET /language/datasets` | The call has timed out due to large data size. By default, this call returns 25 datasets. If the datasets contain many examples, use the `offset` and `count` parameters to limit and page through the data. | #### Training Error codes that can occur when you train a dataset to create a model or access a model. | HTTP Code | HTTP Message | API Message | Resource | Possible Causes | | --- | --- | --- | --- | --- | | 400 | Bad Request | The `name` parameter is required to train; a valid `datasetId` parameter is required to create an example. | `POST /language/train` | The `name` or `datasetId` parameter was passed in, but no value was provided. | | 400 | Bad Request | The `name` or `datasetId` parameters are required to train. | `POST /language/train` | The `name` or `datasetId` parameter is missing. | | 400 | Bad Request | Invalid id `` | `GET /language/train/` | There's no model with an ID that matches the `modelId` parameter. | | 400 | Bad Request | Invalid id `` | `GET /language/train//lc` | There's no model with an ID that matches the `modelId` parameter. | | 400 | Bad Request | The job has not terminated yet; its current status is RUNNING or QUEUED. | `GET /language/models/` | The model for which you are getting metrics hasn't completed training. | | 404 | Not Found | None | `GET /language/models/` | The `modelId` parameter is missing. | | 405 | Method Not Allowed | None | `GET /language/train/` | The `modelId` parameter is missing. | #### Prediction Error codes that can occur when you make a prediction. | HTTP Code | HTTP Message | API Message | Resource | Possible Causes | | --- | --- | --- | --- | --- | | 400 | Bad Request | None | `POST /language/intent` | The prediction request couldn't be fulfilled because the HTTP request was malformed, the Content Type was incorrect, there were missing parameters, or a parameter was provided with an invalid value. | | 400 | Bad Request | Bad Request: Bad sampleLocation | `POST /language/intent` | The URL passed in the `sampleLocation` parameter is invalid. The URL could be incorrect, contain the wrong file name, or the file may have been moved. | | 400 | Bad Request | The `modelId` parameter is required. | `POST /language/intent` | The `modelId` parameter is missing. | | 400 | Bad Request | File size limit exceeded | `POST /language/intent` | The file you passed in for prediction exceeds the maximum file size limit of 5 MB. | | 400 | Bad Request | Bad Request: Unsupported sample file format | `POST /language/intent` | The file you passed in for prediction isn't one of the supported file types. | | 403 | Forbidden | Forbidden! | `POST /language/intent` | The model specified by the `modelId` parameter doesn't exist; or the `modelId` parameter was passed in but no value was provided. | | 429 | Too Many Requests | You've reached the maximum number of predictions. | `POST /language/intent` | You have exceeded the number of prediction requests for your current plan. Contact your AE to update your plan. See [Rate Limits](https://developer.salesforce.com/docs/analytics/einstein-vision-language/guide/rate-limits.html). | **Version:** 1.0 Contact: Salesforce Einstein, einstein-ep-appservicefoundation@salesforce.com, https://www.einstein.com Terms of service: https://developer.salesforce.com/files/tos/Developerforce\_TOU\_20101119.pdf ## Servers * `https://api.einstein.ai` Default security: bearerAuth. ## Security * `bearerAuth` (http) Use a bearer access token in the `Authorization` header: `Authorization: Bearer `. Obtain access tokens by calling `POST /v2/oauth2/token`. * HTTP scheme: bearer (OAuth 2.0 access token) * `einsteinOAuth2` (oauth2) Einstein Vision and Language issues access tokens from `POST /v2/oauth2/token`. This API accepts form-encoded OAuth token grant parameters such as `grant_type=urn:ietf:params:oauth:grant-type:jwt-bearer` and `grant_type=refresh_token`. OpenAPI 3.0 does not model the JWT bearer grant exactly, so this scheme documents the token URL and access-token usage. * OAuth flow clientCredentials (tokenUrl: https://api.einstein.ai/v2/oauth2/token) ## Tags ### OAuth Token Generate and delete OAuth tokens with these API calls. ### API Usage Returns prediction usage on a monthly basis for the current calendar month and future months. ### Datasets (Language) Create, get, and delete Einstein Language datasets using these API calls. ### Examples (Language) Create, get, and delete Einstein Language examples using these API calls. ### Training (Language) Train, retrain, and get training status of Einstein Language datasets with these API calls. ### Models (Language) Get Einstein Language models, model metrics, and model learning curves with these API calls. ### Predictions (Language) Resources that return predictions for text input. ### Vision Prediction Get Einstein Language models, model metrics, and model learning curves with these API calls. ## Operations ### GET Get API Usage `GET /v2/apiusage` Operation ID: `getApiUsageV2`. Tags: API Usage. Each `apiusage` object in the response contains plan information for a single calendar month for a single license. If you have a six-month paid plan and you make this call on the first month, the response contains six `apiusage` objects; one for each calendar month in the plan. For more information about plans, see [Rate Limits](https://developer.salesforce.com/docs/analytics/einstein-vision-language/guide/rate-limits.html). This the cURL request for this call. ```cURL curl -X GET -H "Authorization: Bearer " -H "Cache-Control: no-cache" https://api.einstein.ai/v2/apiusage ``` * If you're using the free tier, the response contains plan information only for the current month. You see plan information only after you make your first prediction. If you call the `/apiusage` resource before you make your first prediction call, the API returns an empty array. * If you're using the paid tier, the response contains plan information for each month in your plan starting with the current month. The `planData` array contains an object for each plan type associated with the calendar month and the license. This code snippet shows the `planData` if the user has two Heroku GOLD plans. ```json "planData": [ { "plan": "GOLD", "amount": 2, "source": "HEROKU" } ] ``` #### Responses * **200** API usage Media type: `application/json`. Schema: `ApiUsageList`. * **500** Failed to get usage ### DELETE Delete a Refresh Token `DELETE /v2/oauth2/tokens/{refreshToken}` Operation ID: `deleteRefreshToken`. Tags: OAuth Token. This call doesn't return a response body. Instead, it returns an HTTP status code `204`. This is the cURL request. ```cURL curl -X DELETE -H "Authorization: Bearer " -H "Cache-Control: no-cache" https://api.einstein.ai/v2/oauth2/tokens/ ``` #### Parameters * `Authorization` (header, string) * `refreshToken` (path, string, required) The refresh token to revoke. _Example_ ``` SOME_REFRESH_TOKEN ``` #### Responses * **204** Token is deleted successfully * **400** Bad request ### POST Generate an OAuth Token `POST /v2/oauth2/token` Operation ID: `generateToken`. Tags: OAuth Token. Returns an OAuth access token. You must pass a valid access token in the header of each API call. For information about how to create an access token, see [Generate an OAuth Token Using Your Key](https://developer.salesforce.com/docs/analytics/einstein-vision-language/guide/generate-an-oauth-token-using-your-key.html?q=oauth). For information about how to create a refresh token, see [Generate an OAuth Token Using a Refresh Token](https://developer.salesforce.com/docs/analytics/einstein-vision-language/guide/generate-an-oauth-token-using-a-refresh-token.html?q=oauth). This is the cURL request for generating an access or refresh token. ```cURL // Generate an access token curl -H "Content-type: application/x-www-form-urlencoded" -X POST https://api.einstein.ai/v2/oauth2/token -d "grant_type=urn:ietf:params:oauth:grant-type:jwt-bearer&assertion=" // Generate a refresh token curl -H "Content-type: application/x-www-form-urlencoded" -X POST https://api.einstein.ai/v2/oauth2/token -d "grant_type=urn:ietf:params:oauth:grant-type:jwt-bearer&assertion=&scope=offline" ``` #### Request body Media type: `application/x-www-form-urlencoded`. Schema: `object`. * `assertion` (_string_) encrypted payload to identify yourself Example: `SOME_ASSERTION_STRING`. * `scope` (_string_) set to `offline` to generate a refresh token Example: `offline`. * `grant_type` (_string_, required) specify the authentication method desired Allowed values: `urn:ietf:params:oauth:grant-type:jwt-bearer`, `refresh_token`. Example: `urn:ietf:params:oauth:grant-type:jwt-bearer`. * `refresh_token` (_string_) The refresh token you created previously. Example: `SomeRefreshToken`. * `valid_for` (_integer (int32)_) Number of seconds until the access token expires. Default is 60 seconds. Maximum value is 30 days Default: `60`. Example: `120`. #### Responses * **200** Access token result Media type: `application/json`. Schema: `GenerateAccessTokenResponse`. * **400** Bad request ### POST insightJSON `POST /v2/language/analyze` Operation ID: `insightJSON`. Tags: Predictions (Language). #### Request body (required) Conversation turn & historical dialogues Media type: `application/json`. Schema: `ELURequest`. #### Responses * **200** Generate NLU insights Media type: `application/json`. Schema: `ELUResponse`. #### Code samples _Example: cURL · curl_ ``` curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: application/json" -d '{"text":"","locale":"en_US","timeZone":"America/Los_Angeles","context":{"models":[{"id":"","type":"intents","numResults":1}],"dialogue":[{"agent":1,"text":""}]},"agent":1}' "https://api.einstein.ai/v2/language/analyze" ``` ### POST Detect Entities in Text `POST /v2/language/entities` Operation ID: `entitiesMultipart`. Tags: Predictions (Language). The Einstein NER (beta) named-entity recognition (NER) model returns entities for a specified string. **Note:** As a beta feature, Einstein NER is a preview and isn’t part of the “Services” under your Main Services Agreement with Salesforce. Use this feature at your sole discretion, and make your purchase decisions only on the basis of generally available products and features. Salesforce doesn’t guarantee general availability of this feature within any particular time frame or at all, and we can discontinue it at any time. This feature is for evaluation purposes only, not for production use. It’s offered as is and isn’t supported, and Salesforce has no liability for any harm or damage arising out of or in connection with it. All restrictions, Salesforce reservation of rights, obligations concerning the Services, and terms for related Non-Salesforce Applications and Content apply equally to your use of this feature. #### Request Parameters | Name | Type | Description | Available Version | | --- | --- | --- | --- | | `document` | string | Text to classify. Maximum length is 3,000 characters. | 2.0 | | `language` | string | Language of the document parameter. Optional. Valid values: Brazilian Portuguese `pt_BR`; Chinese (Simplified) `zh_CN`; Chinese (Traditional) `zh_TW`; Danish (beta) `da`; Dutch `nl_NL`; English UK `en_GB`; English US `en_US`; French `fr`; German `de`; Italian `it`; Japanese `ja`; Korean (beta) `ko`; Portuguese `pt_PT`; Russian `ru`; Spanish `es`; Swedish (beta) `sv`. | 2.0 | | `modelId` | string | ID of the model. Optional. Defaults to `ENTITIES`. | 2.0 | | `timeZone` | string | Time zone of the returned DATETIME entity. Optional. Defaults to `America/Los_Angeles`. See this list of [tz database time zones](https://en.wikipedia.org/wiki/List_of_tz_database_time_zones) for valid time zones, and use the TZ database name value from the table. For example, `Africa/Abidjan`. | 2.0 | | `sampleId` | string | String that you can pass in to tag the prediction. Optional. Can be any value, and is returned in the response. | 2.0 | **Note:** As a beta feature, Danish, Korean, and Swedish language support is a preview and isn’t part of the “Services” under your master subscription agreement with Salesforce. Use this feature at your sole discretion, and make your purchase decisions only on the basis of generally available products and features. Salesforce doesn’t guarantee general availability of this feature within any particular time frame or at all, and we can discontinue it at any time. This feature is for evaluation purposes only, not for production use. It’s offered as is and isn’t supported, and Salesforce has no liability for any harm or damage arising out of or in connection with it. All restrictions, Salesforce reservation of rights, obligations concerning the Services, and terms for related Non-Salesforce Applications and Content apply equally to your use of this feature. This is an example of the cURL request with parameters. ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: multipart/form-data" -F "document=Marc Benioff, the CEO of Salesforce, gave the keynote speech at the conference in Paris last week." https://api.einstein.ai/v2/language/entities ``` Keep the following points in mind: * **Response Sort Order**—The entities returned in the response are sorted by the `span` `start` value. This is the start position in the `document` parameter string of the words the the API recognizes as an entity. #### Pass Request Parameters as JSON When you call the NER endpoint, you can specify a Content-Type of `application/json` and pass the request parameters as JSON. ```json { "modelId": "ENTITIES", "language": "en_US", "document": "Marc Benioff, the CEO of Salesforce, gave the keynote speech at the conference in Paris last week." } ``` The cURL call looks like this. _Windows_ ```cURL curl -X POST -H "Authorization: Bearer " -H "Content-Type: application/json" -d "{\"modelId\":\"ENTITIES\", \"language\": \"en_US\", \"document\":\"Marc Benioff, the CEO of Salesforce, gave the keynote speech at the conference in Paris last week.\"}" https://api.einstein.ai/v2/language/entities ``` _Linux_ ```cURL curl -X POST -H "Authorization: Bearer " -H "Content-Type: application/json" -d '{"modelId":"ENTITIES", "language": "en_US", "document":"Marc Benioff, the CEO of Salesforce, gave the keynote speech at the conference in Paris last week."}' https://api.einstein.ai/v2/language/entities ``` #### Request body Media type: `multipart/form-data`. Schema: `EntitiesPredictRequest`. #### Responses * **200** Prediction result Media type: `application/json`. Schema: `EntitiesPredictResponse`. * **429** Exceed usage limitation Media type: `application/json`. Schema: `PredictionErrorResponse`. ### POST Prediction for Intent `POST /v2/language/intent` Operation ID: `intentMultipart`. Tags: Predictions (Language). Returns an intent prediction for the given string. #### Request Parameters | Name | Type | Description | Available Version | | --- | --- | --- | --- | | `document` | string | Text for which you want to return an intent prediction. | 2.0 | | `modelId` | string | ID of the model that makes the prediction. The model must have been created from a dataset with a type of `text-intent`. | 2.0 | | `numResults` | int | Number of probabilities to return. Optional. If passed, must be a number greater than zero. The response is sorted by `probability` in descending order. For example, if you pass in 3, only the top three `label` and `probability` values are returned. | 2.0 | | `sampleId` | string | String that you can pass in to tag the prediction. Optional. Can be any value, and is returned in the response. | 2.0 | This is an example of the cURL request with parameters. ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: multipart/form-data" -F "modelId=WEQ6PHPBGFYVX5C7QDP6XU3NXY" -F "document=what is the weather in los angeles" https://api.einstein.ai/v2/language/intent ``` Keep the following points in mind when sending text in for prediction: * If you omit the `numResults` parameter, the response returns probabilities for all the labels in the model. #### Passing Parameters as JSON As an alternative to passing the `modelId` and `document` parameters as multipart/form-data fields, you can pass those parameters as JSON. You can pass the JSON directly as a string or reference a file that contains the JSON. This cURL call sends a JSON string into a case routing model for classification. The `Content-Type` has changed to `application/json`. ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: application/json" -d "{\"modelId\":\"2ELVAO5BNVGZLBHMYTV7CGD5AY\",\"document\":\"my password stopped working\"}" https://api.einstein.ai/v2/language/intent ``` Here's what the response might look like. ```json { "probabilities": [ { "label": "Password Help", "probability": 0.99040705 }, { "label": "Order Change", "probability": 0.003532466 }, { "label": "Shipping Info", "probability": 0.003473858 }, { "label": "Billing", "probability": 0.0024010758 }, { "label": "Sales Opportunity", "probability": 0.00018560764 } ], "object": "predictresponse" } ``` You can store the JSON in a file and reference that file. For example, the file intent.json might look like the following. ```json { "modelId": "2ELVAO5BNVGZLBHMYTV7CGD5AY", "document": "my password stopped working" } ``` This cURL call references that file. ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: application/json" -d @c:\data\intent.json https://api.einstein.ai/v2/language/intent ``` ##### Rate Limit Headers Any time you make an API call to the `/intent` resource, your rate limit information is returned in the header. The rate limit headers specify your prediction usage for the current calendar month only. ```text X-RateLimit-Limit 2000 X-RateLimit-Remaining 1997 X-RateLimit-Reset 2017-04-01 19:31:42.0 ``` | Header | Description | Example | | --- | --- | --- | | `X-RateLimit-Limit` | Maximum number of prediction calls available for the current plan month. | 2000 | | `X-RateLimit-Remaining` | Total number of prediction calls you have left for the current plan month. | 1997 | | `X-RateLimit-Reset` | Date on which your predictions are next provisioned. Always the first of the month. | 2017-04-01 22:07:40.0 | #### Request body Media type: `multipart/form-data`. Schema: `IntentPredictRequest`. Media type: `application/json`. Schema: `IntentPredictRequest`. #### Responses * **200** Prediction result Media type: `application/json`. Schema: `IntentPredictResponse`. * **400** Bad request * **404** Not found * **429** Exceed usage limitation Media type: `application/json`. Schema: `PredictionErrorResponse`. ### POST Prediction for Sentiment `POST /v2/language/sentiment` Operation ID: `sentimentMultipart`. Tags: Predictions (Language). Returns a sentiment prediction for the given string. #### Request Parameters | Name | Type | Description | Available Version | | --- | --- | --- | --- | | `document` | string | Text for which you want to return a sentiment prediction. | 2.0 | | `modelId` | string | ID of the model that makes the prediction. The model must have been created from a dataset with a type of `text-sentiment`. | 2.0 | | `numResults` | int | Number of probabilities to return. Optional. If passed, must be a number greater than zero. The response is sorted by `probability` in descending order. For example, if you pass in 3, only the top three `label` and `probability` values are returned. | 2.0 | | `sampleId` | string | String that you can pass in to tag the prediction. Optional. Can be any value, and is returned in the response. | 2.0 | This is an example of the cURL request with parameters. ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: multipart/form-data" -F "modelId=WJH4YCA7YX4PCWVNCYNWYHBMY4" -F "document=I can't tell you how much fun it was" https://api.einstein.ai/v2/language/sentiment ``` Keep the following points in mind when sending text in for prediction: * If you omit the `numResults` parameter, the response returns probabilities for all the labels in the model. #### Passing Parameters as JSON As an alternative to passing the `modelId` and `document` parameters as multipart/form-data fields, you can pass those parameters as JSON. You can pass the JSON directly as a string or reference a file that contains the JSON. This cURL call sends a JSON string into the prebuilt sentiment model for classification. The `Content-Type` has changed to `application/json`. ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: application/json" -d "{\"modelId\":\"CommunitySentiment\",\"document\":\"The presentation was great and I learned a lot\"}" https://api.einstein.ai/v2/language/sentiment ``` Here's what the response might look like. ```json { "probabilities": [ { "label": "positive", "probability": 0.8673582 }, { "label": "negative", "probability": 0.1316828 }, { "label": "neutral", "probability": 0.0009590242 } ], "object": "predictresponse" } ``` You can store the JSON in a file and reference that file. For example, the file sentiment.json might look like the following. ```json { "modelId": "CommunitySentiment", "document": "The presentation was great and I learned a lot" } ``` This cURL call references that file. ```cURL curl -X POST -H "Authorization: Bearer " -H "Cache-Control: no-cache" -H "Content-Type: application/json" -d @c:\data\sentiment.json https://api.einstein.ai/v2/language/sentiment ``` ##### Rate Limit Headers Any time you make an API call to the `/sentiment` resource, your rate limit information is returned in the header. The rate limit headers specify your prediction usage for the current calendar month only. ```text X-RateLimit-Limit 2000 X-RateLimit-Remaining 1997 X-RateLimit-Reset 2017-04-01 19:31:42.0 ``` | Header | Description | Example | | --- | --- | --- | | `X-RateLimit-Limit` | Maximum number of prediction calls available for the current plan month. | 2000 | | `X-RateLimit-Remaining` | Total number of prediction calls you have left for the current plan month. | 1997 | | `X-RateLimit-Reset` | Date on which your predictions are next provisioned. Always the first of the month. | 2017-04-01 22:07:40.0 | #### Request body Media type: `multipart/form-data`. Schema: `SentimentPredictRequest`. Media type: `application/json`. Schema: `SentimentPredictRequest`. #### Responses * **200** Prediction result Media type: `application/json`. Schema: `SentimentPredictResponse`. * **400** Bad request * **404** Not found * **429** Exceed usage limitation Media type: `application/json`. Schema: `PredictionErrorResponse`. ### GET Get a Dataset `GET /v2/language/datasets/{datasetId}` Operation ID: `getDataset`. Tags: Datasets (Language). Returns a single dataset. #### Parameters * `datasetId` (path, integer (int64), required) Dataset Id _Example_ ``` SomeDatasetId ``` #### Responses * **200** Success Media type: `application/json`. Schema: `Dataset`. * **404** Not found #### Code samples _Example: cURL · curl_ ``` curl -X GET -H "Authorization: Bearer " -H "Cache-Control: no-cache" "https://api.einstein.ai/v2/language/datasets/" ``` ### DELETE Delete a Dataset `DELETE /v2/language/datasets/{datasetId}` Operation ID: `deleteDataset`. Tags: Datasets (Language). Deletes the specified text dataset and its labels and examples. This is an example of the cURL request. ```cURL curl -X DELETE -H "Authorization: Bearer " -H "Cache-Control: no-cache" https://api.einstein.ai/v2/language/datasets/10008 ``` Keep the following points in mind when deleting a dataset. * If a dataset is being trained and has an associated model with a status of `QUEUED` or `RUNNING`, you must wait until the training is complete before you can delete the dataset. * If you want to delete a dataset and the models associated with it, delete the models first. Deleting a dataset doesn't delete the models created from that dataset. After you delete a dataset, you can still make predictions against the associated models, but you lose the ability to list the models for the deleted dataset. **Important:** As of August 14, 2023 Get Deletion Status has been deprecated and will no longer be supported by Salesforce. Deletion is now immediate. To determine if the a dataset has been deleted use the Get Dataset command. A deleted dataset will return a 404 (Not Found) http status. * After you delete a dataset, use the `id` to get the status of the deletion. See Get Deletion Status. #### Parameters * `datasetId` (path, integer (int64), required) Dataset Id _Example_ ``` SomeDatasetId ``` #### Responses * **200** Success, deletion job created Media type: `application/json`. Schema: `DeletionResponse`. * **404** Not found ### GET Get All Examples `GET /v2/language/datasets/{datasetId}/examples` Operation ID: `getExamples`. Tags: Examples (Language). Returns all the examples for the specified dataset. This is an example of the cURL request. ```cURL curl -X GET -H "Authorization: Bearer " -H "Cache-Control: no-cache" https://api.einstein.ai/v2/language/datasets/57/examples ``` #### Page Through Examples By default, this call returns 100 examples. If you want to page through the examples in a dataset, use the `offset` and `count` query parameters. | Name | Type | Description | Available Version | | --- | --- | --- | --- | | `count` | int | Number of examples to return. Maximum valid value is 100. If you specify a number greater than 100, the call returns 100 examples. Optional. | 1.0 | | `offset` | int | Index of the example from which you want to start paging. Optional. | 1.0 | Here's an example of these query parameters. If you omit the `count` parameter or the `count` parameter is greater than 100, the API returns 100 examples. If you omit the `offset` parameter, paging starts at 0. ```cURL curl -X GET -H "Authorization: Bearer " -H "Cache-Control: no-cache" "https://api.einstein.ai/v2/language/datasets/57/examples?offset=100&count=50" ``` ##### How Paging Works To page through all the examples in a dataset: 1. Make the Get a Dataset call to return the `totalExamples` value for the dataset. 2. Make the Get All Examples call and pass in the `offset` and `count` values until you reach the end of the examples. For example, let's say you have a dataset and you want to display information about the examples in a UI and show 15 at a time. The first call would have `offset=0` and `count=15`, the second call would have `offset=15` and `count=15`, and so on. #### Return Specific Example Types Use the `source` query parameter to return examples that were created in the dataset. * `all`—Return upload examples. * `upload`—Return examples that were created from uploading a file. #### Limits Each Einstein Vision and Language account is limited to 30 calls per calendar month to Einstein Language endpoints that return examples. This limit applies across all APIs that return examples. If you exceed this limit, you receive an error message. See [Release Notes](https://developer.salesforce.com/docs/analytics/einstein-vision-language/guide/release-notes-einstein-platform-services.html). #### Parameters * `datasetId` (path, integer (int64), required) Dataset Id _Example_ ``` SomeDatasetId ``` * `offset` (query, integer (
[...]
